## com.lowagie.bc.asn1
Class DERGeneralizedTime

    java.lang.Object
      com.lowagie.bc.asn1.DERObject
          com.lowagie.bc.asn1.DERGeneralizedTime

All Implemented Interfaces:
  DEREncodable, DERTags

public class DERGeneralizedTime
extends DERObject

Generalized time object.

Field Summary
`(package private) String` `time`

Fields inherited from interface com.lowagie.bc.asn1.DERTags
`APPLICATION, BIT_STRING, BMP_STRING, BOOLEAN, CONSTRUCTED, ENUMERATED, EXTERNAL, GENERAL_STRING, GENERALIZED_TIME, GRAPHIC_STRING, IA5_STRING, INTEGER, NULL, NUMERIC_STRING, OBJECT_IDENTIFIER, OCTET_STRING, PRINTABLE_STRING, SEQUENCE, SEQUENCE_OF, SET, SET_OF, T61_STRING, TAGGED, UNIVERSAL_STRING, UTC_TIME, UTF8_STRING, VIDEOTEX_STRING, VISIBLE_STRING`

Constructor Summary
`(package private)` `DERGeneralizedTime(byte[] bytes)`
`` `DERGeneralizedTime(Date time)` base constructer from a java.util.date object
`` `DERGeneralizedTime(String time)` The correct format for this is YYYYMMDDHHMMSSZ, or without the Z for local time, or Z+-HHMM on the end, for difference between local time and UTC time.

Method Summary
`(package private) void` `encode(DEROutputStream out)`
`boolean` `equals(Object o)`
`Date` `getDate()`
`static DERGeneralizedTime` `getInstance(ASN1TaggedObject obj, boolean explicit)` return a Generalized Time object from a tagged object.
`static DERGeneralizedTime` `getInstance(Object obj)` return a generalized time from the passed in object
`private byte[]` `getOctets()`
`String` `getTime()` return the time - always in the form of YYYYMMDDhhmmssGMT(+hh:mm|-hh:mm).

Methods inherited from class com.lowagie.bc.asn1.DERObject
`getDERObject`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### time

    String time

Constructor Detail

### DERGeneralizedTime

    public DERGeneralizedTime(String time)

  The correct format for this is YYYYMMDDHHMMSSZ, or without the Z for local time, or Z+-HHMM on the end, for difference between local time and UTC time.

Parameters:
  `time` - the time string.

### DERGeneralizedTime

    public DERGeneralizedTime(Date time)

  base constructer from a java.util.date object

### DERGeneralizedTime

    DERGeneralizedTime(byte[] bytes)

Method Detail

### getInstance

    public static DERGeneralizedTime getInstance(Object obj)

  return a generalized time from the passed in object

  Throws:
    `IllegalArgumentException` - if the object cannot be converted.

### getInstance

    public static DERGeneralizedTime getInstance(ASN1TaggedObject obj,
                                                 boolean explicit)

  return a Generalized Time object from a tagged object.

  Parameters:
    `obj` - the tagged object holding the object we want
    `explicit` - true if the object is meant to be explicitly tagged false otherwise.
  Throws:
    `IllegalArgumentException` - if the tagged object cannot be converted.

### getTime

    public String getTime()

  return the time - always in the form of YYYYMMDDhhmmssGMT(+hh:mm|-hh:mm).

  Normally in a certificate we would expect "Z" rather than "GMT", however adding the "GMT" means we can just use:

           dateF = new SimpleDateFormat("yyyyMMddHHmmssz");

  To read in the time and get a date which is compatible with our local time zone.

### getDate

    public Date getDate()
                 throws ParseException

  Throws:
    `ParseException`

### getOctets

    private byte[] getOctets()

### encode

    void encode(DEROutputStream out)
          throws IOException

  Specified by:
    `encode` in class `DERObject`
  Throws:
    `IOException`

### equals

    public boolean equals(Object o)